package lekcija5;

import java.util.ArrayList; // probati sa LinkedList i Vector
import java.io.*;

@SuppressWarnings("serial")
public class XCDStorage implements Serializable {
	
	private ArrayList<CDDisk> arhiva;
	
	XCDStorage() {
		arhiva = new ArrayList<CDDisk>();
	}
	
	public boolean addCD(CDDisk d) {
		for(int i = 0; i < arhiva.size(); i++)
			if((arhiva.get(i)).getId() == d.getId())
				return false;
		return arhiva.add(new CDDisk(d.getNaziv(), d.getIzvodjac(), d.getId()));
	}
	
	public CDDisk removeCD(int id) {
		for(int i = 0; i < arhiva.size(); i++)
			if((arhiva.get(i)).getId() == id)
				return arhiva.remove(i);
		return null;
	}
	
	public CDDisk searchCD(int id) {
		for(int i = 0; i < arhiva.size(); i++)
			if((arhiva.get(i)).getId() == id)
				return arhiva.get(i);
		return null;
	}
	
	public String toString() {
		if(arhiva.isEmpty()) return "U arhivi nema diskova!";
		String retVal = "Sadrzaj CD arhive je:\n";
		for(int i = 0; i < arhiva.size(); i++)
			retVal += arhiva.get(i) + "\n";
//		for(CDDisk d: arhiva)
//			retVal += d + "\n";
		return retVal;
	}
	
	public void clear(){
		arhiva.clear();
	}

	public boolean addNewCD(){
		boolean retVal=false;
		String naziv=null, autor=null;
		int id=-1;
			
		BufferedReader in = null;		
		try {
			in = new BufferedReader(new InputStreamReader(System.in));
			System.out.print("Unesite naziv CD-a: ");
			naziv = in.readLine();
			System.out.print("Unesite ime autora: ");
			autor = in.readLine();
			while(id==-1) {
				System.out.print("Unesite identifikacioni broj: ");
				try{
					id = Integer.parseInt(in.readLine());
				} catch(NumberFormatException nfe) {
					System.out.print("Identifikacioni broj mora biti celobrojna vrednost! ");
				}
			}
			retVal = addCD(new CDDisk(naziv,autor,id));
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if(in != null)
				try {
					in.close();
				} catch (Exception e) {
					e.printStackTrace();
				}
		}
		return retVal;
	}

	public void save(String file){
		ObjectOutputStream out = null;
		try {
			out = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream(file)));
			out.writeObject(arhiva);
		} catch (Exception e) {
			e.printStackTrace();
        } finally {
            if(out != null)
                try {
                    out.close();
                } catch (Exception e) {
        			e.printStackTrace();
                }
        }
	}
	
	@SuppressWarnings("unchecked")
	public void load(String file){
		ObjectInputStream in = null;
		try {
			in = new ObjectInputStream(new BufferedInputStream(new FileInputStream(file)));
			arhiva = (ArrayList<CDDisk>) in.readObject();
		} catch (Exception e) {
			e.printStackTrace();
        } finally {
            if(in != null)
                try {
                    in.close();
                } catch (Exception e) {
        			e.printStackTrace();
                }
        }
	}

	public void saveText(String file) {
		BufferedWriter out = null;
		try {
			out = new BufferedWriter(new FileWriter(file));
			out.write("CD[ naziv, autor, ID ]");
			out.newLine();
			out.write("----------------------");
			out.newLine();
			for(int i = 0; i < arhiva.size(); i++) {
				out.write(arhiva.get(i).toString());
				out.newLine();
			}
		} catch (Exception e){
			e.printStackTrace();
        } finally {
            if(out != null)
                try {
                    out.close();
                } catch (Exception e) {
        			e.printStackTrace();
                }
        }
	}
	
	public static void main(String[] args) {
		XCDStorage cds = new XCDStorage();
		CDDisk d1 = new CDDisk("Stari disk", "Orkestar", 1);
		CDDisk d2 = new CDDisk("Novi disk", "Orkestar", 2);
		
		System.out.println(cds);
		
		cds.addCD(d1);
		cds.addCD(d2);
		cds.addNewCD();
		System.out.println(cds);
		
		CDDisk removed = cds.removeCD(2);
		if(removed != null) 
			System.out.println("Uklonjen disk: " + removed);
		
		CDDisk nadjen = cds.searchCD(1);
		if(nadjen != null) 
			System.out.println("Nadjen disk: " + nadjen);

		System.out.println("*******************************");
		cds.save("cdarhiva.dat");
		System.out.println("Podaci sacuvani u datoteku!");
		System.out.println(cds);

		System.out.println("*******************************");
		cds.clear();
		System.out.println("Podaci obrisani iz arhive!");
		System.out.println(cds);

		System.out.println("*******************************");
		cds.load("cdarhiva.dat");
		System.out.println("Podaci ucitani iz datoteke!");
		System.out.println(cds);

		System.out.println("*******************************");
		cds.saveText("cdarhiva.txt");
		System.out.println("Podaci sacuvani u tekstualnu datoteku!");
		System.out.println(cds);
	}

}
